from zope.app import zapi
from zope.i18n import interpolate
from zope.i18n.interfaces import INegotiator, ITranslationDomain
from zope.app.component import queryNextUtility
from zope.app.i18n import translationdomain

def translate(self, msgid, mapping=None, context=None,
              target_language=None, default=None):
    """See interface `ITranslationDomain`"""
    if target_language is None and context is not None:
        avail_langs = self.getAvailableLanguages()
        # Let's negotiate the language to translate to. :)
        negotiator = zapi.getUtility(INegotiator, context=self)
        target_language = negotiator.getLanguage(avail_langs, context)

    # Get the translation. Default is the source text itself.
    catalog_names = self._catalogs.get(target_language, [])

    for name in catalog_names:
        catalog = super(translationdomain.TranslationDomain, self).__getitem__(
            name)
        text = catalog.queryMessage(msgid)
        if text is not None:
            break
    else:
        # If nothing found, delegate to a translation server higher up the
        # tree.
        domain = queryNextUtility(context, ITranslationDomain, self.domain)
        if domain is not None:
            return domain.translate(msgid, mapping, context,
                                    target_language, default=0)
        if default is None:
            default = msgid
        text = default

    # Now we need to do the interpolation
    return interpolate(text, mapping)

# This is fixed in Zope 3.3 but sadly it's not being ported back
translationdomain.TranslationDomain.translate = translate



from Products.Five.i18n import FiveTranslationService
save_translate = FiveTranslationService.translate

def translate(self, domain, msgid, mapping=None,
              context=None, target_language=None, default=None):
    if mapping is not None:
        for key, value in list(mapping.items()):
            if isinstance(value, str):
                mapping[key] = value.decode('UTF-8')
    
    return save_translate(self, domain, msgid, mapping,
                          context, target_language, default)

# We're making sure that all keys provided in the mapping are of type
# unicode
FiveTranslationService.translate = translate
